// Written by TeTeT for F/A-18

// Electronic Warfare mission

// for testing right now, see if shutting down radars work and makes the Hornet survive flying over two Tigris

AAs = [Tigris1, Tigris2];
tgt = vehicle player;
js_jc_fa18_jammingDistance = 5000;

[] spawn {
	private _AAs = AAs;
	private _target = tgt;
	while {alive player} do {
		private _res = [];
		{
			private _ka = _x knowsAbout _target;
			_res pushBack format ["%1: %2", _x, _ka];
		} forEach _AAs;
		hint str _res;
		sleep 1;
	};

};

js_jc_fa18_fnc_electronicWarfare = {
	private _target = tgt;
	private _AAs = AAs;
	js_jc_fa18_jamming = true;
	_target vehicleChat "Jamming Started";
	while {alive _target and js_jc_fa18_jamming} do {
		{
			if (_x distance _target < js_jc_fa18_jammingDistance) then {
				// force off
				_x setVehicleRadar 2;
				_x forgetTarget _target;
			};
			sleep 0.1;
		} forEach _AAs;
		sleep 10;
	};
	_target vehicleChat "Jamming Stopped";
};

js_jc_fa18_jamming = false;


tgt addAction [
	"<t color='#ffd700'>Jamming Start</t>",
	"call js_jc_fa18_fnc_electronicWarfare;",
	nil,
	5,
	false,
	true,
	"",
	"!js_jc_fa18_jamming and ((assignedVehicleRole _this) # 0) isEqualTo 'Turret' and _this in _target"
];

tgt addAction [
	"<t color='#ffd700'>Jamming Stop</t>",
	"js_jc_fa18_jamming = false;",
	nil,
	5,
	false,
	true,
	"",
	"js_jc_fa18_jamming and ((assignedVehicleRole _this) # 0) isEqualTo 'Turret' and _this in _target"
];


js_jc_fa18_showRwrGUI = {
	private _jammer = tgt;
	private _AAs = AAs;
	private _dsp = findDisplay 46;
	while {alive _jammer and dialog} do {
		{
			private _txt = _x getVariable ["js_jc_fa18_jamText", objNull];
			private _txtContent = _x getVariable ["js_jc_fa18_jamTextContent", objNull];
			if (_x distance _jammer < js_jc_fa18_jammingDistance) then {
				private _txt = _x getVariable ["js_jc_fa18_jamText", objNull];
				if (isNull _txt) then {
					_txt = _dsp ctrlCreate ["RscStructuredText", -1];
					_x setVariable ["js_jc_fa18_jamText", _txt];
					_txtContent = parseText format ["<t size='0.5'>%1</t>", (getText (configFile >> "CfgVehicles" >> typeOf _x >> "displayName"))];
					_x setVariable ["js_jc_fa18_jamTextContent", _txtContent];
				};
				_txt ctrlSetStructuredText _txtContent;


				// somehow need to get the position from the direction of the AA towards the jammer
				// 0,0 is top left, 1,1 is lower right
				// unclear if jammer is smart here or if it should better be the AA target
				private _ka = _x knowsAbout _jammer;
				private _dist = if (_ka isEqualTo 0) then {
					_txt ctrlSetTextColor [0,0,1,1];
					0.4; 
				} else {
					_txt ctrlSetTextColor [1,0,0,_ka];
					0.2; 
				};

				// need a -90 degree offset due to orientation of screen coordinates
				private _dir = ((_jammer getRelDir _x) - 90) % 360;

				private _xcoord = 0.5 + _dist * ( cos _dir );
				private _ycoord = 0.5 + _dist * ( sin _dir );

				_txt ctrlSetPosition [_xcoord, _ycoord];
				_txt ctrlCommit 0;
			} else {
				// cleanup if out of range
				if (!isNull _txt) then {
					_x setVariable ["js_jc_fa18_jamText", nil];
					ctrlDelete _txt;
				};					
			};
		} forEach _AAs;
		sleep 0.1;
	};
	{
		// cleanup when stop jamming
		private _txt = _x getVariable ["js_jc_fa18_jamText", ObjNull];
		if (!isNull _txt) then {
			_x setVariable ["js_jc_fa18_jamText", nil];
			ctrlDelete _txt;
		};
		closeDialog 2;
	} forEach _AAs;
};

tgt addAction [
	"<t color='#ffd700'>Jamming Interface</t>",
	"createDialog 'TTT_dialog_jamming'; call js_jc_fa18_showRwrGUI",
	nil,
	5,
	false,
	true,
	"",
	"!dialog and ((assignedVehicleRole _this) # 0) isEqualTo 'Turret' and _this in _target"	
];
